Bug 1313025 - dracut won't picking up new mpt3sas driver after upgrading kernel to 4.4.2-301
dracut won't picking up new mpt3sas driver after upgrading kernel to 4.4.2-301
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: dracut (Show other bugs)
23
x86_64 Linux
unspecified Severity high
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
:
: 1312178 (view as bug list)
Depends On:
Blocks: 1390743
  Show dependency treegraph
 
Reported: 2016-02-29 13:39 EST by Anton Barsukov
Modified: 2016-12-20 14:08 EST (History)
14 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 1390743 (view as bug list)
Environment:
Last Closed: 2016-12-20 14:08:18 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Anton Barsukov 2016-02-29 13:39:21 EST
Description of problem:
With kernel update 4.4.2-301.fc23.x86_64 driver mpt2sas have been replaced by mpt3sas so dracut won't picking up new driver and boot will fail. 

Version-Release number of selected component (if applicable):
kernel-4.4.2-301.fc23.x86_64

How reproducible:
upgrade kernel to 4.4.2-301.fc23.x86_64

Steps to Reproduce:
1. dnf update -y kernel\*
2. reboot
3. fail to boot

Actual results:
failed boot/dracut fall into emergency shell

Expected results:
successful boot

Additional info:
to fix this unexpected behaviour after kernel upgrade and *BEFORE* reboot need to be done:

# add new mpt3sas driver to initramfs image
dracut --force --add-drivers mpt3sas --kver=4.4.2-301.fc23.x86_64

# ensure that mpt3sas driver exist in initramfs image
lsinitrd -k 4.4.2-301.fc23.x86_64 | grep mpt3sas

# reboot machine
systemctl reboot
Comment 1 Anton Barsukov 2016-02-29 13:43:14 EST
zbox ~ # ll /lib/modules
total 12
drwxr-xr-x. 5 root root 4096 Feb 15 17:09 4.3.4-300.fc23.x86_64
drwxr-xr-x. 6 root root 4096 Feb 15 17:09 4.3.5-300.fc23.x86_64
drwxr-xr-x. 6 root root 4096 Feb 29 21:36 4.4.2-301.fc23.x86_64

zbox ~ # lsinitrd -k 4.3.4-300.fc23.x86_64 | egrep 'mpt[23]sas'
drwxr-xr-x   2 root     root            0 Feb  1 10:25 usr/lib/modules/4.3.4-300.fc23.x86_64/kernel/drivers/scsi/mpt2sas
-rw-r--r--   1 root     root        81456 Jan 25 19:27 usr/lib/modules/4.3.4-300.fc23.x86_64/kernel/drivers/scsi/mpt2sas/mpt2sas.ko.xz

zbox ~ # lsinitrd -k 4.3.5-300.fc23.x86_64 | egrep 'mpt[23]sas'
drwxr-xr-x   2 root     root            0 Feb 29 23:12 usr/lib/modules/4.3.5-300.fc23.x86_64/kernel/drivers/scsi/mpt2sas
-rw-r--r--   1 root     root        81284 Feb  1 09:08 usr/lib/modules/4.3.5-300.fc23.x86_64/kernel/drivers/scsi/mpt2sas/mpt2sas.ko.xz

zbox ~ # lsinitrd -k 4.4.2-301.fc23.x86_64 | egrep 'mpt[23]sas'
Arguments: -f -v --add-drivers 'mpt3sas' --kver '4.4.2-301.fc23.x86_64'
drwxr-xr-x   2 root     root            0 Feb 29 23:22 usr/lib/modules/4.4.2-301.fc23.x86_64/kernel/drivers/scsi/mpt3sas
-rw-r--r--   1 root     root        87684 Feb 24 00:46 usr/lib/modules/4.4.2-301.fc23.x86_64/kernel/drivers/scsi/mpt3sas/mpt3sas.ko.xz

zbox ~ # lspci | grep MPT
02:00.0 Serial Attached SCSI controller: LSI Logic / Symbios Logic SAS2308 PCI-Express Fusion-MPT SAS-2 (rev 03)
zbox ~ #
Comment 2 Josh Boyer 2016-02-29 13:47:52 EST
This seems like something that dracut needs to fix, not the kernel.  The kernel has a modalias in mpt3sas for mpt2sas already:

[jwboyer@vader ~]$ modinfo mpt3sas
filename:       /lib/modules/4.4.2-300.fc23.x86_64/kernel/drivers/scsi/mpt3sas/mpt3sas.ko.xz
alias:          mpt2sas
version:        09.102.00.00
license:        GPL
description:    LSI MPT Fusion SAS 3.0 Device Driver
author:         Avago Technologies <MPT-FusionLinux.pdl@avagotech.com>

Also, what is the lspci -nnvv output for your MPT card?  We can check that the mpt3sas driver has an alias for the PCI data as well.
Comment 3 Anton Barsukov 2016-02-29 13:50:19 EST
zbox ~ # lspci -nnvv -s 02:00.0
02:00.0 Serial Attached SCSI controller [0107]: LSI Logic / Symbios Logic SAS2308 PCI-Express Fusion-MPT SAS-2 [1000:0086] (rev 03)
	Subsystem: Hewlett-Packard Company Device [103c:158b]
	Control: I/O+ Mem+ BusMaster+ SpecCycle- MemWINV- VGASnoop- ParErr- Stepping- SERR+ FastB2B- DisINTx+
	Status: Cap+ 66MHz- UDF- FastB2B- ParErr- DEVSEL=fast >TAbort- <TAbort- <MAbort- >SERR- <PERR- INTx-
	Latency: 0, Cache Line Size: 64 bytes
	Interrupt: pin A routed to IRQ 0
	Region 0: I/O ports at c000 [size=256]
	Region 1: Memory at de240000 (64-bit, non-prefetchable) [size=64K]
	Region 3: Memory at de200000 (64-bit, non-prefetchable) [size=256K]
	Expansion ROM at de100000 [disabled] [size=1M]
	Capabilities: [50] Power Management version 3
		Flags: PMEClk- DSI- D1+ D2+ AuxCurrent=0mA PME(D0-,D1-,D2-,D3hot-,D3cold-)
		Status: D0 NoSoftRst+ PME-Enable- DSel=0 DScale=0 PME-
	Capabilities: [68] Express (v2) Endpoint, MSI 00
		DevCap:	MaxPayload 4096 bytes, PhantFunc 0, Latency L0s <64ns, L1 <1us
			ExtTag+ AttnBtn- AttnInd- PwrInd- RBE+ FLReset+
		DevCtl:	Report errors: Correctable+ Non-Fatal+ Fatal+ Unsupported+
			RlxdOrd- ExtTag+ PhantFunc- AuxPwr- NoSnoop+ FLReset-
			MaxPayload 256 bytes, MaxReadReq 1024 bytes
		DevSta:	CorrErr- UncorrErr- FatalErr- UnsuppReq- AuxPwr- TransPend-
		LnkCap:	Port #0, Speed 8GT/s, Width x4, ASPM L0s, Exit Latency L0s <64ns, L1 <1us
			ClockPM- Surprise- LLActRep- BwNot- ASPMOptComp+
		LnkCtl:	ASPM Disabled; RCB 64 bytes Disabled- CommClk+
			ExtSynch- ClockPM- AutWidDis- BWInt- AutBWInt-
		LnkSta:	Speed 5GT/s, Width x4, TrErr- Train- SlotClk+ DLActive- BWMgmt- ABWMgmt-
		DevCap2: Completion Timeout: Range BC, TimeoutDis+, LTR-, OBFF Not Supported
		DevCtl2: Completion Timeout: 50us to 50ms, TimeoutDis-, LTR-, OBFF Disabled
		LnkCtl2: Target Link Speed: 8GT/s, EnterCompliance- SpeedDis-
			 Transmit Margin: Normal Operating Range, EnterModifiedCompliance- ComplianceSOS-
			 Compliance De-emphasis: -6dB
		LnkSta2: Current De-emphasis Level: -3.5dB, EqualizationComplete-, EqualizationPhase1-
			 EqualizationPhase2-, EqualizationPhase3-, LinkEqualizationRequest-
	Capabilities: [d0] Vital Product Data
		Unknown small resource type 00, will not decode more.
	Capabilities: [a8] MSI: Enable- Count=1/1 Maskable- 64bit+
		Address: 0000000000000000  Data: 0000
	Capabilities: [c0] MSI-X: Enable+ Count=16 Masked-
		Vector table: BAR=1 offset=0000e000
		PBA: BAR=1 offset=0000f000
	Capabilities: [100 v2] Advanced Error Reporting
		UESta:	DLP- SDES- TLP- FCP- CmpltTO- CmpltAbrt- UnxCmplt- RxOF- MalfTLP- ECRC- UnsupReq- ACSViol-
		UEMsk:	DLP- SDES- TLP- FCP- CmpltTO- CmpltAbrt- UnxCmplt- RxOF- MalfTLP- ECRC- UnsupReq- ACSViol-
		UESvrt:	DLP+ SDES+ TLP- FCP+ CmpltTO- CmpltAbrt- UnxCmplt- RxOF+ MalfTLP+ ECRC- UnsupReq- ACSViol-
		CESta:	RxErr- BadTLP- BadDLLP- Rollover- Timeout- NonFatalErr-
		CEMsk:	RxErr- BadTLP- BadDLLP- Rollover- Timeout- NonFatalErr+
		AERCap:	First Error Pointer: 00, GenCap- CGenEn- ChkCap- ChkEn-
	Capabilities: [1e0 v1] #19
	Capabilities: [1c0 v1] Power Budgeting <?>
	Capabilities: [190 v1] #16
	Capabilities: [148 v1] Alternative Routing-ID Interpretation (ARI)
		ARICap:	MFVC- ACS-, Next Function: 0
		ARICtl:	MFVC- ACS-, Function Group: 0
	Kernel driver in use: mpt3sas
	Kernel modules: mpt3sas
Comment 4 Laura Abbott 2016-02-29 17:07:43 EST
*** Bug 1312178 has been marked as a duplicate of this bug. ***
Comment 5 Sammy 2016-03-01 11:02:46 EST
Yes, manually including mpt3sas module solved the problem on DELL T7610. I did 
get a screen message:

mpt2sas_cm0: Overriding NVDATA EEDPTagMode setting.

Whatever that means. Thanks.
Comment 6 Jason Tibbitts 2016-03-02 16:21:49 EST
I note, though it might be obvious: Once you've actually managed to get the newer kernel to boot, dracut will do the right thing and install the mpt3sas module without being told.  So as long as you don't boot back to 4.3.x and then install a new kernel package, things should be OK.
Comment 7 Hugo Salgado 2016-03-16 09:39:39 EDT
Just to confirm the bug on a Dell Precision T7610 desktop with Fedora 22 in a normal update from kernel 4.3.6-201 to 4.4.3-201. Solved adding 

add_drivers+="mpt3sas"

to /etc/dracut.conf and generating a new initramfs for 4.4.3.
Comment 8 Sammy 2016-03-16 09:42:38 EDT
Yes, it was Fedora 23 on Dell Precision T7610. Subsequent kernels do fine
and don't need the add_drivers any more as explained in Comment 6.
Comment 9 Sam Tygier 2016-04-08 08:51:25 EDT
Same issue going from 4.2.3-300 to 4.4.6-300 on a Dell Poweredge R815.

dracut --force --add-drivers mpt3sas --kver=4.4.6-300.fc23.x86_64

Fixed it for me.
Comment 10 Fedora End Of Life 2016-11-24 10:51:15 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 11 Fedora End Of Life 2016-12-20 14:08:18 EST
Fedora 23 changed to end-of-life (EOL) status on 2016-12-20. Fedora 23 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.